/*
 * ds v1.0.0 (C) 1997 Mikael Klasson aka Fluff of Logic Design
 *
 * enjoy...
 */

#include <stdio.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <unistd.h>


#define VERSION "1.0.0"


int processdir( char *, int, int );


void main( int argc, char **argv )
{
	int		i, size, totalsize = 0;
	int		mode = 11; 	/* 1	  = help 
					 * 10 + i = dirs start at argv[i] 
					 */

	for( i = 1; i < argc; i++ ) {
		if( !strcasecmp( argv[i], "-h" ) || !strcasecmp( argv[i], "--help" ) ) mode = 1;
		else if( !strcasecmp( argv[i], "--" ) ) {
			mode = 10 + i;
			break;
		}
	}

	if( argc < 2 ) {
		printf( "ds: usage: ds [OPTIONS] [--] DIRECTORY [DIRECTORIES...]\n" );
		printf( "for help, try: ds --help\n" );
		return;
	} 

	if( mode == 1 ) {
		printf( "\nds v%s (C) 1997 Mikael Klasson aka Fluff of Logic Design\n", VERSION );
		printf( "usage: ds [OPTIONS] [--] DIRNAME [DIRNAMES...]\n\n" );
		printf( "  -h, --help		print this help message\n\n" );
		printf( "this program shows the total size of dirs, including their subdirs.\n" );
		printf( "Everything after -- is interpreted as dirnames\n\n");
		return;
	}

	for( i = mode - 10; argv[i]; i++ ) {
		printf( "ds: %-20s = ", argv[i] );
		fflush( stdout );
		size = processdir( argv[i], 0, 0 );
		totalsize += size;
		printf( "%d, %dKB, %dMB\n", size, size / 1024, size / 1024 / 1024 );
	}
	printf( "\nds: total                = %d, %dKB, %dMB\n", totalsize, totalsize / 1024, totalsize / 1024 / 1024 );
}


int processdir( char *dirname, int depth, int totalsize )
{
	struct dirent	*dir_ent;
	struct DIR	*dir;
	struct stat	statbuf;

	if( chdir( dirname ) ) return totalsize;

	if( ( dir = opendir( "." ) ) ) {
		while( ( dir_ent = readdir( dir ) ) ) {
			lstat( dir_ent->d_name, &statbuf );
			if( S_ISDIR( statbuf.st_mode ) && !S_ISLNK( statbuf.st_mode ) && strcmp( dir_ent->d_name, "." ) && strcmp( dir_ent->d_name, ".." ) )
				totalsize = processdir( dir_ent->d_name, depth + 1, totalsize );
			else if( S_ISREG( statbuf.st_mode ) ) totalsize += statbuf.st_size;
		}
		closedir( dir );
	}

	chdir( ".." );

	return totalsize;
}
